"use strict";Object.defineProperty(exports, "__esModule", { value: true });exports.commandBuild = exports.commandServe = exports.commandSync = undefined;var _actionNames = require("../constants/actionNames");
var _watcherActions = require("../watcher/watcherActions");
var _socketActions = require("../socket/socketActions");
var _serverActions = require("../server/serverActions");


























var _child_process = require("mz/child_process");
var _path = require("path");
var _fs = require("mz/fs");var _fs2 = _interopRequireDefault(_fs);function _interopRequireDefault(obj) {return obj && obj.__esModule ? obj : { default: obj };}var commandSync = exports.commandSync = function commandSync(config) {return function (dispatch) {dispatch({ type: _actionNames.COMMAND_SYNC, config: config });dispatch((0, _watcherActions.watcherWatch)());dispatch((0, _socketActions.socketConnect)(config.devServer));};};var commandServe = exports.commandServe = function commandServe(config) {return function (dispatch) {dispatch({ type: _actionNames.COMMAND_SERVE, config: config });dispatch((0, _serverActions.serverListen)());};}; /**
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      * HACK SECTION
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      * This isn't reduxy yet but I really need building to work so here we are. What this should
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      * really do: first "load a package" the same way watch does. Then trigger all these other actions
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      * in order, but separate them out so that watch has access to them.
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      */ /* eslint-disable no-console */var spawnLog = function spawnLog(command, args, options) {console.log("Running " + command + " " + args.join(" "));var proc = (0, _child_process.spawn)(command, args, options);proc.stdout.on("data", function (data) {
    console.log("stdout: " + data.toString().trim());
  });
  proc.stderr.on("data", function (data) {
    // Hack for https://github.com/yarnpkg/yarn/issues/2538
    var str = data.toString().trim();
    console.log("stderr: " + str);
    if (str.indexOf("Your lockfile needs to be updated") !== -1) {
      throw new Error("needs lockfile update");
    }
  });
  return new Promise(function (resolve, reject) {
    proc.on("close", function (code) {
      if (code !== 0) {
        var err = new Error(
        command + " " + args.join(" ") + " exited with code " + code);

        err.exitCode = code;
        return reject(err);
      }
      resolve();
    });
  });
};

var commandBuild = exports.commandBuild = function commandBuild(config) {return function (dispatch) {var
    dockerPrefix = config.dockerPrefix,dockerTag = config.dockerTag,directory = config.directory;
    console.log("Building " + directory);
    var needsDocker = true;
    var dockerName = void 0;
    var spawn = function spawn(file) {for (var _len = arguments.length, args = Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {args[_key - 1] = arguments[_key];}
      return spawnLog(file, args, {
        cwd: directory });

    };
    try {
      _fs2.default.statSync((0, _path.resolve)(directory, "Dockerfile"));
    } catch (e) {
      if (e.code !== "ENOENT") {
        throw e;
      }
      needsDocker = false;
    }
    var pkg = void 0;
    return Promise.resolve().
    then(function () {
      return _fs2.default.readFile((0, _path.resolve)(directory, "package.json"), "utf8");
    }).
    then(function (pkgStr) {
      pkg = JSON.parse(pkgStr);
      dockerName = dockerPrefix + "/" + pkg.name + ":" + dockerTag;
      return spawn("yarn", "install", "--frozen-lockfile");
    }).
    then(function () {
      if (pkg.scripts.build) {
        return spawn("npm", "run", "build");
      }
    }).
    then(function () {
      if (needsDocker) {
        return spawn("docker", "build", "-t", dockerName, ".");
      }
    }).
    then(function () {
      if (needsDocker) {
        return spawn("docker", "push", dockerName);
      }
    }).
    then(function () {
      return _fs2.default.readdir((0, _path.resolve)(directory, "packages")).catch(function (err) {
        if (err.code !== "ENOENT") {
          throw err;
        }
        return [];
      });
    }).
    then(function (packages) {
      var doOne = function doOne() {
        if (packages.length === 0) {
          return;
        }
        var newPkg = packages.pop();
        return dispatch(
        commandBuild({
          dockerPrefix: dockerPrefix,
          dockerTag: dockerTag,
          directory: (0, _path.resolve)(directory, "packages", newPkg) })).

        then(doOne);
      };
      return doOne();
    }).
    catch(function (err) {
      console.error(err);
      process.exit(err.exitCode || 1);
    });
  };};