"use strict";Object.defineProperty(exports, "__esModule", { value: true });exports.default =








getConfig;var _jsYaml = require("js-yaml");var _mkdirpPromise = require("mkdirp-promise");var _path = require("path");var _fs = require("mz/fs");var _fs2 = _interopRequireDefault(_fs);function _interopRequireDefault(obj) {return obj && obj.__esModule ? obj : { default: obj };}var CONFIG_DEFAULT = { authServer: "https://stream.place" };function getConfig(program) {var
  spConfig = program.spConfig;
  var stat = void 0;
  try {
    stat = _fs2.default.statSync(spConfig);
  } catch (e) {
    // Create if it doesn't exist.
    if (e.code !== "ENOENT") {
      throw e;
    }
    (0, _mkdirpPromise.sync)((0, _path.dirname)(spConfig));
    _fs2.default.writeFileSync(spConfig, (0, _jsYaml.safeDump)(CONFIG_DEFAULT));
  }
  var data = _fs2.default.readFileSync(spConfig, "utf8");
  return (0, _jsYaml.safeLoad)(data);
}