"use strict";Object.defineProperty(exports, "__esModule", { value: true });exports.serverListen = undefined;var _ws = require("ws");var _ws2 = _interopRequireDefault(_ws);
var _actionNames = require("../constants/actionNames");function _interopRequireDefault(obj) {return obj && obj.__esModule ? obj : { default: obj };}






var serverListen = exports.serverListen = function serverListen() {return function (dispatch, getState) {
    var port = getState().socket.port;
    dispatch({
      type: _actionNames.SERVER_LISTEN,
      port: port });


    var wss = new _ws2.default.Server({ port: port });
    wss.on("listening", function () {
      dispatch({
        type: _actionNames.SERVER_LISTEN_SUCCESS,
        port: port });

    });

    wss.on("connection", function (socket) {
      socket.on("message", function (data, _ref) {var binary = _ref.binary,masked = _ref.masked;
        if (binary) {
          // console.log(`Got ${data.length} bytes`);
        } else {
            // console.log(`Got ${data}`);
          }
      });
    });
  };};