"use strict";Object.defineProperty(exports, "__esModule", { value: true });exports.default =



terminalRender;var _terminalKit = require("terminal-kit");function _toConsumableArray(arr) {if (Array.isArray(arr)) {for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) {arr2[i] = arr[i];}return arr2;} else {return Array.from(arr);}}var hasPrinted = new Set();function terminalRender(store) {
  // term.fullscreen();
  // term.alternateScreenBuffer();

  store.subscribe(function () {var _term$underline, _term$underline2;var _store$getState$termi =






    store.getState().terminal,title = _store$getState$termi.title,status = _store$getState$termi.status,entries = _store$getState$termi.entries,categories = _store$getState$termi.categories,bottomBar = _store$getState$termi.bottomBar;

    _terminalKit.terminal.eraseDisplayBelow();

    // This is a memory leak, woo
    entries.forEach(function (entry) {
      if (hasPrinted.has(entry)) {
        return;
      }
      hasPrinted.add(entry);
      var cat = categories[entry.category];
      _terminalKit.terminal.colorRgb.apply(_terminalKit.terminal, _toConsumableArray(cat.color))(cat.name + " ");
      _terminalKit.terminal.colorRgb(255, 255, 255)(entry.text + "\n");
    });

    if (bottomBar !== true) {
      return;
    }

    // Set up bottom bar
    var titleText = " " + title.text + " ";
    var statusText = " " + status.text + " ";
    var neededSpacing = _terminalKit.terminal.width - titleText.length - statusText.length;
    var spacing = "";
    while (spacing.length < neededSpacing) {
      spacing += " ";
    }
    (0, _terminalKit.terminal)("\n");
    _terminalKit.terminal.up(1);

    _terminalKit.terminal.down(1);
    (_term$underline = _terminalKit.terminal.underline).colorRgb.apply(_term$underline, _toConsumableArray(title.color))(titleText);
    _terminalKit.terminal.underline.colorRgb(255, 255, 255)(spacing);
    (_term$underline2 = _terminalKit.terminal.underline).colorRgb.apply(_term$underline2, _toConsumableArray(status.color))(statusText);
    _terminalKit.terminal.up(1);
    _terminalKit.terminal.column(1);
    _terminalKit.terminal.styleReset();
  });
}