"use strict";Object.defineProperty(exports, "__esModule", { value: true });exports.watcherLoadFile = exports.watcherUnlink = exports.watcherChange = exports.watcherAdd = exports.watcherWatch = undefined;exports.



































watcherReady = watcherReady;var _chokidar = require("chokidar");var _chokidar2 = _interopRequireDefault(_chokidar);var _fs = require("mz/fs");var _fs2 = _interopRequireDefault(_fs);var _socketActions = require("../socket/socketActions");var _actionNames = require("../constants/actionNames");function _interopRequireDefault(obj) {return obj && obj.__esModule ? obj : { default: obj };}var IGNORED = ["node_modules", "dist"];var watcherWatch = exports.watcherWatch = function watcherWatch() {return function (dispatch) {_chokidar2.default.watch(".", { ignored: IGNORED }).on("ready", function () {dispatch(watcherReady());}) // Chokidar's funny and calls everything twice, with the stat block the second time. We only
    // care then.
    .on("add", function (path, stat) {if (!stat) {return;}dispatch(watcherAdd(path, stat));}).on("change", function (path, stat) {if (!stat) {return;}dispatch(watcherChange(path, stat));});};};function watcherReady() {return { type: _actionNames.WATCHER_READY };

}

var watcherAdd = exports.watcherAdd = function watcherAdd(path, stat) {return function (dispatch) {
    return Promise.resolve().then(function () {
      dispatch({
        type: _actionNames.WATCHER_ADD,
        path: path,
        stat: stat });

      return dispatch(watcherLoadFile(path));
    });
  };};

var watcherChange = exports.watcherChange = function watcherChange(path, stat) {return function (dispatch) {
    return Promise.resolve().then(function () {
      dispatch({
        type: _actionNames.WATCHER_CHANGE,
        path: path,
        stat: stat });

      return dispatch(watcherLoadFile(path));
    });
  };};

var watcherUnlink = exports.watcherUnlink = function watcherUnlink(path, stat) {
  return {
    type: _actionNames.WATCHER_UNLINK,
    path: path,
    stat: stat };

};

var watcherLoadFile = exports.watcherLoadFile = function watcherLoadFile(path) {return function (dispatch, getState) {
    return _fs2.default.
    readFile(path).
    then(function (buf) {
      dispatch({
        type: _actionNames.WATCHER_LOAD_FILE_SUCCESS,
        path: path,
        buffer: buf });

      var file = getState().watcher.files[path];
      dispatch((0, _socketActions.socketSendFile)(file));
    }).
    catch(function (err) {
      return dispatch({
        type: _actionNames.WATCHER_LOAD_FILE_ERROR,
        path: path,
        error: err });

    });
  };};