"use strict";Object.defineProperty(exports, "__esModule", { value: true });var _extends = Object.assign || function (target) {for (var i = 1; i < arguments.length; i++) {var source = arguments[i];for (var key in source) {if (Object.prototype.hasOwnProperty.call(source, key)) {target[key] = source[key];}}}return target;};exports.default =






socketReducer;var _actionNames = require("../constants/actionNames");var actions = _interopRequireWildcard(_actionNames);function _interopRequireWildcard(obj) {if (obj && obj.__esModule) {return obj;} else {var newObj = {};if (obj != null) {for (var key in obj) {if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key];}}newObj.default = obj;return newObj;}}var initialState = { connected: false, ws: null };function socketReducer() {var state = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : initialState;var action = arguments[1];
  switch (action.type) {
    case actions.COMMAND_SYNC:
      return _extends({}, state, { devServer: action.config.devServer });

    case actions.COMMAND_SERVE:
      return _extends({}, state, { port: action.config.port });

    case actions.SOCKET_CONNECT_SUCCESS:
      return _extends({}, state, { connected: true, ws: action.ws });

    case actions.SOCKET_CLOSE:
      return _extends({}, state, { connected: false, ws: null });}


  return state;
}