"use strict";Object.defineProperty(exports, "__esModule", { value: true });var _extends = Object.assign || function (target) {for (var i = 1; i < arguments.length; i++) {var source = arguments[i];for (var key in source) {if (Object.prototype.hasOwnProperty.call(source, key)) {target[key] = source[key];}}}return target;};exports.default =






























watcherReducer;var _actionNames = require("../constants/actionNames");var actions = _interopRequireWildcard(_actionNames);function _interopRequireWildcard(obj) {if (obj && obj.__esModule) {return obj;} else {var newObj = {};if (obj != null) {for (var key in obj) {if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key];}}newObj.default = obj;return newObj;}}function _defineProperty(obj, key, value) {if (key in obj) {Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true });} else {obj[key] = value;}return obj;}var initialState = { ready: false, files: {} };function upsertFile(state, action) {var path = action.path;var oldFile = state.files[path] || {};var newFile = _extends({}, oldFile);if (action.stat) {newFile.stat = action.stat;}if (action.buffer) {newFile.buffer = action.buffer;}if (newFile.uploaded === undefined) {newFile.uploaded = false;}return _extends({}, state, { files: _extends({}, state.files, _defineProperty({}, path, newFile)) });}function watcherReducer() {var state = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : initialState;var action = arguments[1];
  switch (action.type) {
    case actions.WATCHER_READY:
      return _extends({},
      state, {
        ready: true });


    case actions.WATCHER_ADD:
      return upsertFile(state, action);

    case actions.WATCHER_CHANGE:
      return upsertFile(state, action);

    case actions.WATCHER_LOAD_FILE_SUCCESS:
      return upsertFile(state, action);}


  return state;
}